Bug 1002157 - Review Request: randomizedtesting - Java Testing Framework
Summary: Review Request: randomizedtesting - Java Testing Framework
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Michael Simacek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On: simple-xml
Blocks: spatial4j 1051536
TreeView+ depends on / blocked
 
Reported: 2013-08-28 14:21 UTC by gil cattaneo
Modified: 2014-02-01 04:03 UTC (History)
1 user (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-02-01 04:03:44 UTC
msimacek: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description gil cattaneo 2013-08-28 14:21:36 UTC
Spec URL: http://gil.fedorapeople.org/randomizedtesting.spec
SRPM URL: http://gil.fedorapeople.org/randomizedtesting-2.0.9-1.fc19.src.rpm
Description:
Foundation classes and rules for applying the
principles of Randomized Testing.
Fedora Account System Username: gil

Comment 1 Michael Simacek 2014-01-15 12:13:51 UTC
I'll do the review.

Comment 2 Michael Simacek 2014-01-17 11:41:12 UTC
Requires
--------
randomizedtesting-runner (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(junit:junit)

randomizedtesting-junit4-maven-plugin (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(com.carrotsearch.randomizedtesting:junit4-ant)
    mvn(com.carrotsearch.randomizedtesting:randomizedtesting-runner)
    mvn(com.google.guava:guava)
    mvn(dom4j:dom4j)
    mvn(org.apache.ant:ant)
    mvn(org.apache.ant:ant-junit)
    mvn(org.apache.maven.plugins:maven-antrun-plugin)
    mvn(org.apache.maven.shared:maven-common-artifact-filters)
    mvn(org.apache.maven:maven-artifact)
    mvn(org.apache.maven:maven-compat)
    mvn(org.apache.maven:maven-core)
    mvn(org.apache.maven:maven-plugin-api)

randomizedtesting (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(org.sonatype.oss:oss-parent)

randomizedtesting-junit4-ant (rpmlib, GLIBC filtered):
    jpackage-utils

randomizedtesting-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

That doesn't seem correct

Comment 3 gil cattaneo 2014-01-17 22:06:48 UTC
(In reply to Michael Simacek from comment #2)
> Requires
> --------
> randomizedtesting-runner (rpmlib, GLIBC filtered):
>     jpackage-utils
>     mvn(junit:junit)
> 
> randomizedtesting-junit4-maven-plugin (rpmlib, GLIBC filtered):
>     jpackage-utils
>     mvn(com.carrotsearch.randomizedtesting:junit4-ant)
>     mvn(com.carrotsearch.randomizedtesting:randomizedtesting-runner)
>     mvn(com.google.guava:guava)
>     mvn(dom4j:dom4j)
>     mvn(org.apache.ant:ant)
>     mvn(org.apache.ant:ant-junit)
>     mvn(org.apache.maven.plugins:maven-antrun-plugin)
>     mvn(org.apache.maven.shared:maven-common-artifact-filters)
>     mvn(org.apache.maven:maven-artifact)
>     mvn(org.apache.maven:maven-compat)
>     mvn(org.apache.maven:maven-core)
>     mvn(org.apache.maven:maven-plugin-api)
> 
> randomizedtesting (rpmlib, GLIBC filtered):
>     jpackage-utils
>     mvn(org.sonatype.oss:oss-parent)
> 
> randomizedtesting-junit4-ant (rpmlib, GLIBC filtered):
>     jpackage-utils
> 
> randomizedtesting-javadoc (rpmlib, GLIBC filtered):
>     jpackage-utils
> 
> That doesn't seem correct

sorry... did not understand what the problem is...

Comment 4 Michael Simacek 2014-01-22 12:18:28 UTC
There are no requires for randomizedtesting-junit4-ant besides jpackage-utils. Its name suggest it should require at least ant and junit4, but the upstream uses <scope>provided</scope> everywhere. This is probably not a problem for depending packages, because if they already use it, they had to specify those dependencies themselves. However it looks like misuse of that scope and you could ask upstream whether they really meant it that way.


Having '%files -f .mfiles-%{name}-parent' looks error prone. It seems better to have just '%files -f .mfiles' and use '%mvn_package :%{name}-parent'. If the upstream ever add something into main package, you wouldn't miss it this way.

Comment 5 gil cattaneo 2014-01-22 13:00:54 UTC
(In reply to Michael Simacek from comment #4)
> There are no requires for randomizedtesting-junit4-ant besides
> jpackage-utils. Its name suggest it should require at least ant and junit4,
> but the upstream uses <scope>provided</scope> everywhere. This is probably
> not a problem for depending packages, because if they already use it, they
> had to specify those dependencies themselves. However it looks like misuse
> of that scope and you could ask upstream whether they really meant it that
> way.
>
this usually is normal ...
> 
> Having '%files -f .mfiles-%{name}-parent' looks error prone. It seems better
> to have just '%files -f .mfiles' and use '%mvn_package :%{name}-parent'. If
> the upstream ever add something into main package, you wouldn't miss it this
> way.

is not possible: mvn-package: Exactly 2 arguments are required.


Spec URL: http://gil.fedorapeople.org/randomizedtesting.spec
SRPM URL: http://gil.fedorapeople.org/randomizedtesting-2.0.9-1.fc19.src.rpm

- merge parent pom with runner sub package

Comment 6 Michael Simacek 2014-01-22 16:19:57 UTC
(In reply to gil cattaneo from comment #5)
> > Having '%files -f .mfiles-%{name}-parent' looks error prone. It seems better
> > to have just '%files -f .mfiles' and use '%mvn_package :%{name}-parent'. If
> > the upstream ever add something into main package, you wouldn't miss it this
> > way.
> 
> is not possible: mvn-package: Exactly 2 arguments are required.
Oh, seems like old version of javapackages-tools (f19 right?). Then it should be possible to use '%mvn_package :%{name}-parent __default' to achieve the same thing. mvn_package with single argument should work from f20 on.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- latest upstream version is 2.0.15
- com/carrotsearch/ant/tasks/junit4/templates/json/js directory bundles some
  JavaScript:
  - jquery.pathchange.js - bundled code under MIT license
  - minified jQuery - this is unacceptable, quoting the guidelines "If a
    JavaScript library typically is shipped as minified or compiled code, it
    must be compiled or minified as part of the RPM build process. Shipping
    pre-minified or pre-compiled code is unacceptable in Fedora."
- it doesn't own /usr/share/java/randomizedtesting
- patch should have a comment stating what it does and why


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[?]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated", "*No copyright* Apache (v2.0)". 358 files have
     unknown license. Detailed output of licensecheck in
     /home/msimacek/1002157-randomizedtesting/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/java/randomizedtesting
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/java/randomizedtesting
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 6 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It is
     pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[?]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     randomizedtesting-junit4-ant , randomizedtesting-junit4-maven-plugin ,
     randomizedtesting-runner , randomizedtesting-javadoc
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: randomizedtesting-2.0.9-1.fc21.noarch.rpm
          randomizedtesting-junit4-ant-2.0.9-1.fc21.noarch.rpm
          randomizedtesting-junit4-maven-plugin-2.0.9-1.fc21.noarch.rpm
          randomizedtesting-runner-2.0.9-1.fc21.noarch.rpm
          randomizedtesting-javadoc-2.0.9-1.fc21.noarch.rpm
          randomizedtesting-2.0.9-1.fc21.src.rpm
6 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint randomizedtesting-runner randomizedtesting-junit4-maven-plugin randomizedtesting randomizedtesting-junit4-ant randomizedtesting-javadoc
5 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
randomizedtesting-runner (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(junit:junit)

randomizedtesting-junit4-maven-plugin (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(com.carrotsearch.randomizedtesting:junit4-ant)
    mvn(com.carrotsearch.randomizedtesting:randomizedtesting-runner)
    mvn(com.google.guava:guava)
    mvn(dom4j:dom4j)
    mvn(org.apache.ant:ant)
    mvn(org.apache.ant:ant-junit)
    mvn(org.apache.maven.plugins:maven-antrun-plugin)
    mvn(org.apache.maven.shared:maven-common-artifact-filters)
    mvn(org.apache.maven:maven-artifact)
    mvn(org.apache.maven:maven-compat)
    mvn(org.apache.maven:maven-core)
    mvn(org.apache.maven:maven-plugin-api)

randomizedtesting (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(org.sonatype.oss:oss-parent)

randomizedtesting-junit4-ant (rpmlib, GLIBC filtered):
    jpackage-utils

randomizedtesting-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
randomizedtesting-runner:
    mvn(com.carrotsearch.randomizedtesting:randomizedtesting-runner)
    osgi(com.carrotsearch.randomizedtesting.randomizedtesting-runner)
    randomizedtesting-runner

randomizedtesting-junit4-maven-plugin:
    mvn(com.carrotsearch.randomizedtesting:junit4-maven-plugin)
    randomizedtesting-junit4-maven-plugin

randomizedtesting:
    mvn(com.carrotsearch.randomizedtesting:randomizedtesting-parent)
    mvn(com.carrotsearch.randomizedtesting:randomizedtesting-parent:pom:)
    randomizedtesting

randomizedtesting-junit4-ant:
    mvn(com.carrotsearch.randomizedtesting:junit4-ant)
    randomizedtesting-junit4-ant

randomizedtesting-javadoc:
    randomizedtesting-javadoc



Source checksums
----------------
https://github.com/carrotsearch/randomizedtesting/archive/release/2.0.9.tar.gz :
  CHECKSUM(SHA256) this package     : d70a0ee8dae7a4d140b536474c2201f4c6d2b08fb3b7f6e2ad4dfa31ad8ea178
  CHECKSUM(SHA256) upstream package : d70a0ee8dae7a4d140b536474c2201f4c6d2b08fb3b7f6e2ad4dfa31ad8ea178


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1002157
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 7 gil cattaneo 2014-01-23 00:25:18 UTC
Spec URL: http://gil.fedorapeople.org/randomizedtesting.spec
SRPM URL: http://gil.fedorapeople.org/randomizedtesting-2.0.15-1.fc19.src.rpm

- update to 2.0.15
. remove bundled JavaScript libraries
- fix unowned directory

Comment 8 Michael Simacek 2014-01-23 10:17:49 UTC
The unowned directory is still not fixed. randomizedtesting-junit4-ant installs into that directory, but doesn't depend on the package that owns it.

You should put that directory (and the licence) into main package and make the subpackages require it (by specifying explicit requires)

In case it's not clear:
%files
%dir %{_javadir}/%{name}
%doc LICENSE

%files junit4-ant -f .mfiles-junit4-ant

%files junit4-maven-plugin -f .mfiles-junit4-maven-plugin

%files runner -f .mfiles-%{name}-runner
%doc randomized-runner/README

%files javadoc -f .mfiles-javadoc
%doc LICENSE


Then add 'Requires: %{name} = %{version}-%{release}' into each subpackage (except javadoc of course). And add an explicit require on jpackage-utils to the main package (needed for %{_javadir}).

Comment 9 gil cattaneo 2014-01-23 10:38:26 UTC
(In reply to Michael Simacek from comment #8)
> The unowned directory is still not fixed. randomizedtesting-junit4-ant
> installs into that directory, but doesn't depend on the package that owns it.
> 
> You should put that directory (and the licence) into main package and make
> the subpackages require it (by specifying explicit requires)
> 
> In case it's not clear:
> %files
> %dir %{_javadir}/%{name}
> %doc LICENSE
> 
> %files junit4-ant -f .mfiles-junit4-ant
> 
> %files junit4-maven-plugin -f .mfiles-junit4-maven-plugin
> 
> %files runner -f .mfiles-%{name}-runner
> %doc randomized-runner/README
> 
> %files javadoc -f .mfiles-javadoc
> %doc LICENSE
> 
> 
> Then add 'Requires: %{name} = %{version}-%{release}' into each subpackage
> (except javadoc of course). And add an explicit require on jpackage-utils to
> the main package (needed for %{_javadir}).
Done

Spec URL: http://gil.fedorapeople.org/randomizedtesting.spec
SRPM URL: http://gil.fedorapeople.org/randomizedtesting-2.0.15-1.fc19.src.rpm

Comment 10 Michael Simacek 2014-01-23 12:19:34 UTC
Require jpackage-utils, not javapackages-tools, that's a different package.
License in those subpackages (except javadoc) is redundant (it is already in the main package which is always installed with them)

Comment 11 gil cattaneo 2014-01-23 12:36:00 UTC
(In reply to Michael Simacek from comment #10)
> Require jpackage-utils, not javapackages-tools, that's a different package.

Sorry but javapackages-tools replace jpackage-utils (retired)
see http://pkgs.fedoraproject.org/cgit/javapackages-tools.git/tree/javapackages-tools.spec
> License in those subpackages (except javadoc) is redundant (it is already in
> the main package which is always installed with them)
Done

Spec URL: http://gil.fedorapeople.org/randomizedtesting.spec
SRPM URL: http://gil.fedorapeople.org/randomizedtesting-2.0.15-1.fc19.src.rpm

Comment 12 Michael Simacek 2014-01-23 13:35:47 UTC
You're right, I didn't realize that.

Koji scratch-build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6444196

Comment 13 gil cattaneo 2014-01-23 13:44:18 UTC
Thanks!

New Package SCM Request
=======================
Package Name: randomizedtesting
Short Description: Java Testing Framework
Owners: gil
Branches: f20
InitialCC: java-sig

Comment 14 Gwyn Ciesla 2014-01-23 14:13:39 UTC
Git done (by process-git-requests).

Comment 15 Fedora Update System 2014-01-23 15:58:02 UTC
randomizedtesting-2.0.15-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/randomizedtesting-2.0.15-1.fc20

Comment 16 Fedora Update System 2014-01-24 07:48:26 UTC
randomizedtesting-2.0.15-1.fc20 has been pushed to the Fedora 20 testing repository.

Comment 17 Fedora Update System 2014-02-01 04:03:44 UTC
randomizedtesting-2.0.15-1.fc20 has been pushed to the Fedora 20 stable repository.


Note You need to log in before you can comment on or make changes to this bug.